#include <sys/types.h>
#include <machine/sysarch.h>
#include <sys/mman.h>
#include <stdio.h>
#include <err.h>
#include <unistd.h>

int
main(void)
{
	void *p = mmap((void *)(1ULL << 31), 4096, PROT_READ|  PROT_WRITE,
		MAP_ANON | MAP_FIXED, -1, 0);
	void *p2;

	if (p == MAP_FAILED) err(1, "mmap");
	*(void **)p = printf;

	if (sysarch(X86_SET_GSBASE, &p))
		err(1, "sysarch");

	if (fork() == 0)
		_exit(0);

	asm volatile("movq %%gs:0, %0" : "=r" (p2));

	printf("%p %p\n", p2, printf);
	return 0;
}
